﻿# YPS Beer (backend)

A super-simple backend for viewing, searching and favouring Beers from the [PunkAPI](https://punkapi.com/).


## Setup

### Requirements

To run in development mode, you will need:
* [.NET 8](https://dotnet.microsoft.com/en-us/download/dotnet/8.0)

> NOTE: By default, the app will run with an `InMemory` database, meaning all data is lost when shutting down the server. When you restart the server, you will need to re-create your account and all login sessions will be lost.


### Running locally
To run in development mode, run:
```sh
cd YPS.Beer/
dotnet run
```

### Configuring
The app should already be setup to work in development mode with the frontend. For configuration options, use `YPS.Beer/appsettings{.Development}.json`

## Technology
To create this project, the following was used:
* .NET 8
* Identity Server
* Entity Framework
* NUnit & NSubstitute

## To improve:
### Testing
I would have preferred to get better integration testing in this project instead of just unit tests, given more time.

### Better Error Handling
There are places where the error handling isn't the best, and instead of returning generic responses it should be returning more specific ones.